part of tecfy_core_client_package;

class EntityAction {
  /// action arabic name
  late String nameAr;

  /// action english name
  late String nameEn;
  String get name => LocalConfigService.isArabic ? nameAr : nameEn;
  late String dbName;
  dynamic modal;
  late List<Property> actionFormProp;
  dynamic actionForm;
  // String showWhen ;
  // String permissionParameter;

  EntityAction.fromMap(Map<String, dynamic> row) {
    nameAr = row['nameAr'];
    nameEn = row['nameEn'];
    dbName = lowerFirst(row['dbName']);
    // showWhen = row['showWhen'];
    // permissionParameter = row['permissionParameter'];

    // if(row['permission'] != null)
    //   permission = Permission.fromMap(row['permission']);

    if (row['actionFormProp'] != null)
      actionFormProp = row['actionFormProp']
          .map<Property?>((p) => Property.getProperty(p))
          .where((e) => e != null)
          .map<Property>((e) => e as Property)
          .toList();
    else
      actionFormProp = [];
  }

  /// lower the fist letter
  String lowerFirst(String s) {
    if (s.isEmpty) return '';
    return '${s[0].toLowerCase()}${s.substring(1)}';
  }
}
